package protocol

import (
	"io"
)

// ClientCodec creates a ClientCodecRequest to process each request.
type ClientCodec interface {
	WriteRequest(w io.Writer, method string, args interface{}, id interface{}) error
	NewResponse(rc io.Reader) (ClientResponseCodec, error)
}

type ClientResponseCodec interface {
	Notification() (ClientNotificationCodec, error)
	Result(result interface{}) error
	Error() error
	ID() interface{}
}

type ClientNotificationCodec interface {
	RegistryCodec
}
